package cn.com.infosec.mobile.android.framework.crypto.impl.gm;

import cn.com.infosec.math.ec.ECCurve;
import cn.com.infosec.math.ec.ECPoint;
import cn.com.infosec.util.BigIntegers;
import java.io.PrintStream;
import java.math.BigInteger;

public class SM2Util {
   private static final int SM2_SIZE = 32;
   private static final BigInteger gmp;
   private static final BigInteger gma;
   private static final BigInteger gmb;
   private static final ECCurve gmec256;
   private static final BigInteger gmgx;
   private static final BigInteger gmgy;
   private static final byte[] sm2abgxgy;

   public static byte[] getZA(byte[] id, byte[] pubkey) {
      byte[] var10001 = id;
      byte[] var10002 = id;
      byte[] var10003 = id;
      byte[] var10004 = id;
      id = new byte[id.length + 2 + 192];
      System.arraycopy(getENTLa(var10004), 0, id, 0, 2);
      int var2 = var10003.length;
      System.arraycopy(var10002, 0, id, 2, var2);
      int var8 = var2 = 2 + var10001.length;
      var10002 = sm2abgxgy;
      int var3 = var10002.length;
      System.arraycopy(var10002, 0, id, var2, var3);
      var2 = var8 + var10002.length;
      byte[] var10000;
      if (pubkey.length == 64) {
         var10000 = pubkey;
         int pubkey1 = pubkey.length;
         System.arraycopy(var10000, 0, id, var2, pubkey1);
      } else if (pubkey.length == 65) {
         System.arraycopy(pubkey, 1, id, var2, 64);
      } else if (pubkey.length == 33) {
         System.arraycopy(pubkey, 1, id, var2, 32);
         var2 += 32;
         byte var6 = pubkey[0];
         pubkey[0] = 0;
         System.arraycopy(BigIntegers.asUnsignedByteArray(getY(new BigInteger(1, pubkey), var6)), 0, id, var2, 32);
      }

      SM3Digest pubkey2;
      SM3Digest var7 = pubkey2 = new SM3Digest;
      var7.<init>();
      var7.update(id);
      var10000 = new byte[32];
      pubkey2.digest(var10000);
      return var10000;
   }

   private static BigInteger getBeta(BigInteger x) {
      BigInteger var1 = null;
      BigInteger var2;
      var2 = new BigInteger.<init>("3");
      BigInteger var3;
      BigInteger var10000 = var3 = gmp;
      x = x.modPow(var2, var3).add(gma.multiply(x)).add(gmb).mod(var3);
      BigInteger[] var5;
      switch ((var5 = var10000.divideAndRemainder(new BigInteger("8")))[1].intValue()) {
         case 5:
            int var4;
            if ((var4 = x.modPow(var5[0].add(var5[0]).add(var1 = BigInteger.ONE), var3).intValue()) != -1) {
               if (var4 != 1) {
                  return null;
               }

               var1 = x.modPow(var5[0].add(var1), var3);
            } else {
               var10000 = x.add(x);
               var1 = var10000.multiply(var10000.add(var10000).modPow(var5[0], var3));
            }
            break;
         case 6:
         case 7:
            var10000 = var1 = x.modPow(var5[0].add(var5[0]).add(BigInteger.ONE), var3);
            if (var10000.multiply(var10000).mod(var3).compareTo(x) != 0) {
               return null;
            }
      }

      return var1;
   }

   static BigInteger getY(BigInteger x, int ypb) {
      if ((x = getBeta(x)) == null) {
         return null;
      } else {
         byte[] var10000 = BigIntegers.asUnsignedByteArray(x);
         return (var10000[var10000.length - 1] & 255) == ypb - 2 ? x : gmp.add(x.negate());
      }
   }

   public static byte[] point2octect(ECPoint p) {
      byte[] var1;
      (var1 = new byte[65])[0] = 4;
      int var2 = BigIntegers.asUnsignedByteArray(p.getX().toBigInteger()).length;

      int var3;
      for(var3 = 0; var3 < 32 - var2; var1[++var3] = 0) {
      }

      byte[] var10001 = BigIntegers.asUnsignedByteArray(p.getX().toBigInteger());
      var3 = 33 - var2;
      System.arraycopy(var10001, 0, var1, var3, var2);
      var2 = BigIntegers.asUnsignedByteArray(p.getY().toBigInteger()).length;

      for(var3 = 0; var3 < 32 - var2; ++var3) {
         var1[var3 + 33] = 0;
      }

      var10001 = BigIntegers.asUnsignedByteArray(p.getY().toBigInteger());
      int p1 = 65 - var2;
      System.arraycopy(var10001, 0, var1, p1, var2);
      return var1;
   }

   public static void point2octect(ECPoint p, byte[] x, byte[] y) {
      System.arraycopy(BigIntegers.asUnsignedByteArray(p.getX().toBigInteger()), 0, x, 0, 32);
      System.arraycopy(BigIntegers.asUnsignedByteArray(p.getY().toBigInteger()), 0, y, 0, 32);
   }

   public static ECPoint octect2point(byte[] pb) {
      byte[] var1 = new byte[32];
      byte[] var2 = new byte[32];
      int var3;
      BigInteger pb1;
      if ((var3 = pb.length) != 33) {
         if (var3 != 64) {
            if (var3 != 65) {
               return null;
            }

            byte var7 = 1;
            byte var4 = 33;
            if (pb[0] != 4) {
               return null;
            }

            System.arraycopy(pb, var7, var1, 0, 32);
            System.arraycopy(pb, var4, var2, 0, 32);
         } else {
            System.arraycopy(pb, 0, var1, 0, 32);
            System.arraycopy(pb, 32, var2, 0, 32);
         }

         ECCurve var8 = gmec256;
         BigInteger var10001 = new BigInteger(1, var1);
         pb1 = new BigInteger.<init>(1, var2);
         return var8.createPoint(var10001, pb1, false);
      } else {
         System.arraycopy(pb, 1, var1, 0, 32);
         BigInteger var6;
         BigInteger var10000 = var6 = new BigInteger;
         var6.<init>(1, var1);
         return (pb1 = getY(var10000, pb[0])) == null ? null : gmec256.createPoint(var6, pb1, false);
      }
   }

   public static ECPoint octect2point(byte[] pb, int offset, int length) {
      byte[] var3 = new byte[32];
      byte[] var4 = new byte[32];
      BigInteger pb1;
      if (length != 33) {
         if (length != 64) {
            if (length != 65) {
               return null;
            }

            length = offset + 1;
            offset += 33;
            if (pb[0] != 4) {
               return null;
            }

            System.arraycopy(pb, length, var3, 0, 32);
            System.arraycopy(pb, offset, var4, 0, 32);
         } else {
            byte[] var8 = pb;
            byte[] var10001 = pb;
            int pb2 = offset + 0;
            offset += 32;
            System.arraycopy(var10001, pb2, var3, 0, 32);
            System.arraycopy(var8, offset, var4, 0, 32);
         }

         ECCurve var9 = gmec256;
         BigInteger var10 = new BigInteger(1, var3);
         pb1 = new BigInteger.<init>(1, var4);
         return var9.createPoint(var10, pb1, false);
      } else {
         System.arraycopy(pb, offset + 1, var3, 0, 32);
         BigInteger length1;
         BigInteger var10000 = length1 = new BigInteger;
         length1.<init>(1, var3);
         return (pb1 = getY(var10000, pb[offset])) == null ? null : gmec256.createPoint(length1, pb1, false);
      }
   }

   static byte[] getENTLa(byte[] id) {
      byte[] var1;
      byte[] var10000 = var1 = new byte[2];
      int var10002 = id.length * 8;
      var1[1] = (byte)(id.length * 8 & 255);
      var10000[0] = (byte)(var10002 >> 8 & 255);
      return var10000;
   }

   public static byte[] kdf(byte[] x2y2, int keySize) {
      if (keySize < 1) {
         return null;
      } else {
         SM3Digest var2;
         var2 = new SM3Digest.<init>();
         byte var3 = 32;
         int var10001 = keySize;
         int var10002 = keySize;
         keySize /= var3;
         int var4 = var10002 % var3;
         byte[] var5 = new byte[var10001];
         byte[] var6 = new byte[32];
         int var7 = 1;

         for(int var8 = 0; var8 < keySize; ++var7) {
            boolean var15;
            SM3Digest var10000;
            byte[] var16;
            byte var10003;
            SM3Digest var10004;
            SM3Digest var10005;
            byte[] var10006;
            byte[] var10007;
            try {
               var10000 = var2;
               var16 = var5;
               var10002 = var8;
               var10003 = var3;
               var10004 = var2;
               var10005 = var2;
               var10006 = x2y2;
               var10007 = I2OSP(var7);
            } catch (Exception var12) {
               var15 = false;
               throw new RuntimeException("internal error");
            }

            byte[] var9 = var10007;

            try {
               var10005.update(var10006);
               var10004.update(var9);
            } catch (Exception var11) {
               var15 = false;
               throw new RuntimeException("internal error");
            }

            var10002 *= var10003;

            try {
               var10000.digest(var16, var10002);
            } catch (Exception var10) {
               var15 = false;
               throw new RuntimeException("internal error");
            }

            ++var8;
         }

         if (var4 != 0) {
            byte[] keySize1 = I2OSP(var7);
            var2.update(x2y2);
            var2.update(keySize1);
            var2.digest(var6);
            int x2y21 = keySize * var3;
            System.arraycopy(var6, 0, var5, x2y21, var4);
         }

         return var5;
      }
   }

   public static byte[] I2OSP(int x) {
      byte[] var1;
      byte[] var10000 = var1 = new byte[4];
      var1[0] = (byte)(x >>> 24);
      var1[1] = (byte)(x >>> 16);
      var1[2] = (byte)(x >>> 8);
      var10000[3] = (byte)x;
      return var10000;
   }

   public static void main(String[] args) {
      byte[] args1 = kdf(new byte[]{100, -46, 13, 39, -48, 99, 41, 87, -8, 2, -116, 30, 2, 79, 107, 2, -19, -14, 49, 2, -91, 102, -55, 50, -82, -117, -42, 19, -88, -24, 101, -2, 88, -46, 37, -20, -89, -124, -82, 48, 10, -127, -94, -44, -126, -127, -88, 40, -31, -50, -33, 17, -60, 33, -112, -103, -124, 2, 101, 55, 80, 119, -65, 120}, 19);

      for(int var1 = 0; var1 < args1.length; ++var1) {
         PrintStream var10000 = System.out;
         Object[] var2;
         (var2 = new Object[1])[0] = args1[var1];
         var10000.print(String.format("%02X", var2));
      }

   }

   static {
      gmp = SM2GMParameter.gmp;
      gma = SM2GMParameter.gma;
      gmb = SM2GMParameter.gmb;
      gmec256 = SM2GMParameter.gmec256;
      gmgx = SM2GMParameter.gmgx;
      gmgy = SM2GMParameter.gmgy;
      sm2abgxgy = new byte[]{-1, -1, -1, -2, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 0, 0, 0, 0, -1, -1, -1, -1, -1, -1, -1, -4, 40, -23, -6, -98, -99, -97, 94, 52, 77, 90, -98, 75, -49, 101, 9, -89, -13, -105, -119, -11, 21, -85, -113, -110, -35, -68, -67, 65, 77, -108, 14, -109, 50, -60, -82, 44, 31, 25, -127, 25, 95, -103, 4, 70, 106, 57, -55, -108, -113, -29, 11, -65, -14, 102, 11, -31, 113, 90, 69, -119, 51, 76, 116, -57, -68, 55, 54, -94, -12, -10, 119, -100, 89, -67, -50, -29, 107, 105, 33, 83, -48, -87, -121, 124, -58, 42, 71, 64, 2, -33, 50, -27, 33, 57, -16, -96};
   }
}
